<template>
  <div :class="prefixCls">
    <Popover
      v-model:visible="visible"
      title=""
      trigger="click"
      :overlayClassName="`${prefixCls}__overlay`"
    >
      <Badge :count="count" dot :numberStyle="numberStyle">
        <BellOutlined />
      </Badge>
      <template #content>
        <Tabs>
          <template v-for="item in listData" :key="item.key">
            <Tabs.TabPane>
              <template #tab>
                {{ item.name }}
                <span v-if="item.list.length !== 0">({{ item.list.length }})</span>
              </template>
              <!-- 绑定title-click事件的通知列表中标题是“可点击”的-->
              <NoticeList :list="item.list" v-if="item.key === '1'" @title-click="onNoticeClick" />
              <NoticeList :list="item.list" v-else />
            </Tabs.TabPane>
          </template>
        </Tabs>
      </template>
    </Popover>
  </div>
</template>
<script lang="ts" setup>
  import { computed, onMounted, ref, h } from 'vue';
  import { Popover, Tabs, Badge } from 'ant-design-vue';
  import { BellOutlined, CloseOutlined } from '@ant-design/icons-vue';
  import { tabListData } from './data';
  import { useDesign } from '@/hooks/web/useDesign';
  import { useMessage } from '@/hooks/web/useMessage';
  import { getLastList, readMsg, getInfoByContentId } from '@/api/demo/message';
  import { useUserStore } from '@/store/modules/user';
  import { useModal } from '@/components/Modal';
  import NoticeList from './NoticeList.vue';
  import { signal } from '@/utils/signalR';
  import { getDetail } from '@/api/sys/WFSchemeInfo';
  import Icon from '@/components/Icon/Icon.vue';

  const [registerModal, { openModal: openLookModal }] = useModal();
  const userStore = useUserStore();
  const userInfo: any = userStore.getUserInfo;
  const visible = ref(false);
  const { prefixCls } = useDesign('header-notify');
  const { createMessage, notification } = useMessage();
  const listData = ref(tabListData);
  const numberStyle = {};
  const auditOpen = ref(false);
  const processId = ref('');
  const taskId = ref('');
  const isRead: any = ref(0);
  const type = ref('');
  const cloudQueryVisible = ref(false);
  const cloudLandQueryVisible = ref(false);
  const showSplitPolygon = ref(false);
  const showInfoData = ref({});
  const compare = ref(false);
  const open = ref(false);
  const SplitPolygonComponent = ref();

  const count = computed(() => {
    let count = 0;
    for (let i = 0; i < listData.value.length; i++) {
      count += listData.value[i].list.length;
    }
    return count;
  });

  async function onNoticeClick(record) {
    console.log(record);
    visible.value = false;
    const index = listData.value[0].list.findIndex((item: any) => item.id === record.id);
    if (index !== -1) {
      listData.value[0].list.splice(index, 1);
    }
    openLookModal(true, {
      record: {
        content: record.title,
        createDate: record.datetime,
        isRead: 0,
      },
    });
    const data = await readMsg({
      id: record.id,
    });
  }
  async function getList() {
    const data = await getLastList({
      userId: userInfo.id,
    });
    let arr: any = [];
    if (data && data.length > 0) {
      data.forEach((item: any) => {
        arr.push({
          id: item.msgId,
          title: item.content,
          datetime: item.createDate,
          contentId: item.contentId,
        });
      });
      listData.value[0].list = arr;
    }
  }

  // 连接
  async function start() {
    try {
      await signal.start().then(() => {
        signal
          .invoke('SendInfo', userInfo.id.toString())
          .catch((err) => console.error(err.toString()));
      });
      console.log('userInfo.id', userInfo.id);
      console.log('SignalR Connected.连接成功');
    } catch (err) {
      console.log(err);
      // setTimeout(start, 5000);
    }
  }
  signal.onclose(async () => {
    await start();
  });
  //接口推送
  signal.on('RevMsg', (user, message, time, id, issystem) => {
    console.log('报警', user, message, time, id, issystem); //拿到后台推送的数据
  });
  onMounted(() => {
    getList();
    start();
  });
</script>
<style lang="less">
  @prefix-cls: ~'@{namespace}-header-notify';

  .@{prefix-cls} {
    padding-bottom: 1px;

    &__overlay {
      max-width: 360px;
    }

    .ant-tabs-content {
      width: 300px;
    }

    .ant-badge {
      display: flex;
      align-items: center;
      font-size: 18px;

      .ant-badge-multiple-words {
        padding: 0 4px;
      }

      svg {
        width: 0.9em;
      }
    }
  }
  .full-modal {
    .ant-modal {
      max-width: 100%;
      top: 0;
    }

    .ant-modal-content {
      height: calc(100vh);
    }

    .ant-modal-body {
      height: 85%;
    }
  }
  .cloudquery-notice {
    background: rgba(0, 0, 0, 0.53);
    padding: 0px 14px;
    border-radius: 6px;
    position: fixed;
    top: 30px;
    right: 1vw;
    width: 700px;
    color: #fff;
    z-index: 10;
    .cloudquery-title {
      height: 40px;
      display: flex;
      justify-content: space-between;
      align-items: center;
      font-size: 16px;
    }
    .cloudquery-left {
      display: flex;
      align-items: center;
    }
    .cloudquery-right {
      display: flex;
      align-items: center;
      justify-content: space-around;
      width: 130px;
    }
    img {
      width: 34px;
      height: 29px;
    }
    .cloudquery-btn {
      display: flex;
      justify-content: flex-end;
    }
    .line {
      background: #ededed;
      width: 1px;
      height: 20px;
    }
    .anticon.anticon-close {
      height: 30px;
    }
    button {
      width: 70px;
      height: 26px;
      background: linear-gradient(-74deg, #086dec, #0b4bdd);
      box-shadow: 3px 4px 5px 1px rgba(13, 13, 13, 0.05);
      border-radius: 16px;
      display: flex;
      align-items: center;
      justify-content: center;
    }
    .title-box {
      margin-left: 10px;
      font-size: 14px;
    }
  }
</style>
<style lang="scss" scoped>
  .search-menu {
    width: 50px;
    height: 355px;
    background-color: #fff;
    position: absolute;
    top: 30px;
    left: 20px;
    border-radius: 25px;
    padding-top: 19px;
  }
  .active {
    background: repeating-linear-gradient(to left, rgb(38, 51, 231), rgb(20, 118, 230));
    color: #fff;
  }
  .menu-item {
    display: flex;
    flex-direction: column;
    align-items: center;
    margin-bottom: 7px;
    cursor: pointer;
    .item-icon {
      font-size: 20px;
      margin-bottom: 2px;
      width: 40px;
      height: 40px;
      display: flex;
      justify-content: center;
      align-items: center;
      border-radius: 50%;
      transition: 0.2s;
    }
    .item-text {
      user-select: none;
    }
  }
  .menu-content {
    padding: 10px;
    background: #fff;
    position: absolute;
    top: 0px;
    left: 70px;
    width: 420px;
  }

  .modal-content {
    padding: 15px;
    width: 100%;
    height: calc(100vh - 65px);
    overflow: auto;
  }
</style>
